library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


--
-- Schnittstellenbeschreibung der Testbench
--
entity speicher_testbench is
	-- Eine Testbench hat keine Ports
end entity;


--
-- Verhaltensbeschreibung der Testbench
--
architecture stimulus of speicher_testbench is

	-- peripherie_test einbinden
	COMPONENT speicher is

	PORT
	(
			adr      : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
			clk		: IN STD_LOGIC;
			wr			: IN STD_LOGIC ;
			data_in	: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
			data_out	: IN  STD_LOGIC_VECTOR (31 DOWNTO 0) 
	);
	end component;
	


	signal clk_stim : std_logic := '1';
	signal address	: STD_LOGIC_VECTOR (7 DOWNTO 0) := (OTHERS => '0');
	signal data_in	 : STD_LOGIC_VECTOR (31 DOWNTO 0);
	signal data_out : STD_LOGIC_VECTOR (31 DOWNTO 0);
	signal wr		: STD_LOGIC := '0';
	
begin
		
	
		-- 1 MHz Takt (2*500ns = 1µs => 1MHz)
		clk_stim <= not clk_stim after 500 ns;
		
		--  Speicher instanzieren
		meinSpeicher: speicher PORT MAP (	
											adr => address,
											clk => clk_stim,
											wr => wr,										
											data_in => data_in,
											data_out => data_out
										);
										
				
		-- Aus dem Speicher lesen
		testSpeicher: process
		begin
				
			-- vorinitialisierten Wert von Adresse 3 (x"03030303") lesen			
			wait until rising_edge(clk_stim);
			address <= x"03";			
				
			-- nach zwei Takten den vorinitialisierten 
			-- Wert von Adresse 5 (x"05050505") lesen			
			wait until rising_edge(clk_stim);
			wait until rising_edge(clk_stim);
			address <= x"05";			
			
			wait;
			
		end process;
							
										
										
		
--		testSpeicher: process
--
--			variable adr: 	 	unsigned (11 DOWNTO 0) := (others => '0');		-- Speicheradresse
--			variable datum: 	unsigned (31 DOWNTO 0) := x"0000_0042";			-- Datenwert
--			variable i: 		integer := 0;												-- Laufvariable
--			
--		begin
--
--		
--		
--			--
--			-- zehn Werte Lesen			<-- beim ersten Durchlauf werden die Vorinitialisierten Werte ausgegeben
--			--		
--
--			cs <= '1';			
--			adr := (others => '0');
--			address <=  STD_LOGIC_VECTOR( unsigned(adr));-- after 5 ns;
--			datum := x"0000_0000";			
--			wren <= '0';-- after 5 ns;
--			
--		
--			for i in 0 to 10 loop
--						
--				rden <= '0';
--				data <= (OTHERS => 'Z');				
--				wait until rising_edge(clk_stim);
--		
--				data <= (OTHERS => 'Z');
--				address <=  STD_LOGIC_VECTOR( unsigned(adr));-- after 5 ns;
--				adr := adr + 1;		
--				rden <= '1';
--				
--				wait until rising_edge(clk_stim);		
--
--				gelesen <= data;
--				rden <= '0';
--				
--			end loop;
--		
--		
--		
--			--
--			-- Leertakt einfügen (und Chip-Select vom RAM nehmen)
--			--
--			cs <= '0';
--			wait until rising_edge(clk_stim);
--			cs <= '1';
--		
--		
--		
--			--
--			-- zehn Werte Schreiben
--			--		
--			adr := (others => '0');
--			datum := x"0000_0042";
--		
--			for i in 0 to 10 loop
--			
--				wait until rising_edge(clk_stim);
--				wren <= '1';
--		
--				address <=  STD_LOGIC_VECTOR( unsigned(adr));-- after 5 ns;
--				adr := adr + 1;						
--				
--				data <= STD_LOGIC_VECTOR( unsigned(datum));-- after 5 ns;
--				datum := datum + 1;		
--				
--				-- komplette Periode abwarten und dann WR-Enable ausschalten
--				wait until rising_edge(clk_stim);
--				
--			end loop;
--			
--			
--			--
--			-- Schreiben beendet, daher Schreibsignal wegnehmen und Datenbus freigeben
--			--
--			wren <= '0';
--			data <= (OTHERS => 'Z');
--			
--			
--		end process;
		



		
end stimulus;